import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:hgg_base/src/utils/x_size.dart';

/// 将 Padding 属性添加到小部件
extension WidgetPaddingX on Widget {
  Widget paddingHv({double horizontal = 0.0, double vertical = 0.0}) => Padding(
        padding: P.hv(horizontal: horizontal, vertical: vertical),
        child: this,
      );

  Widget paddingOnly({
    double left = 0.0,
    double top = 0.0,
    double right = 0.0,
    double bottom = 0.0,
  }) =>
      Padding(
        padding: P.only(top: top, left: left, right: right, bottom: bottom),
        child: this,
      );
}

/// 将 color 属性添加到小部件
extension WidgetColorX on Widget {
  Widget get yellow => ColoredBox(
        color: Colors.yellow,
        child: this,
      );

  Widget get blue => ColoredBox(
        color: Colors.blue,
        child: this,
      );

  Widget get red => ColoredBox(
        color: Colors.red,
        child: this,
      );
}
