typedef OnCodeError = void Function(int code);
typedef OnUnLogin = void Function();

class RespData {
  final dynamic code;
  final String message;
  final dynamic data;
  final bool success;

  final int unLoginCode; //未登录的错误码
  final OnUnLogin? onUnLogin; // 由于cookie过期,所以需要清除本地存储的登录信息
  final OnCodeError? onCodeError;

  final List<String>? containKeys;//包含的固定key,用于把固定 key 以外的 key 装入 data

  RespData({
    required this.code,
    required this.message,
    required this.data,
    required this.success,
    this.unLoginCode = -999,
    this.onUnLogin,
    this.onCodeError,
    this.containKeys,
  });

  Map toJson() {
    return {
      'code': code,
      'message': message,
      'data': data,
      'success': success,
      'unLoginCode': unLoginCode,
      'onUnLogin': onUnLogin,
      'onCodeError': onCodeError,
    };
  }

  @override
  String toString() {
    return 'RespData ${toJson()}';
  }
}
