import 'package:bot_toast/bot_toast.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import 'x_size.dart';

class XMsg {
  static Color _color = Colors.deepPurple;
  static bool _isDark = true;
  static CancelFunc? _hideLoadFun;

  static init(Color color, bool isDark) {
    _color = color;
    _isDark = isDark;
  }

  ///toast 一条消息-顶部主题色背景
  static show(String msg) {
    BotToast.showCustomNotification(
      duration: Duration(seconds: 3),
      toastBuilder: (cancel) {
        return _CustomWidget(
          cancelFunc: cancel,
          msg: msg,
          color: _color,
          isDark: _isDark,
        );
      },
    );
  }

  /// 显示加载中弹框
  static showLoading() {
    _hideLoadFun = BotToast.showCustomLoading(
      clickClose: false,
      toastBuilder: (can) {
        return Container(
          padding: P.all(40),
          decoration: const BoxDecoration(
              color: Colors.black38, borderRadius: BorderRadius.all(Radius.circular(8))),
          child: CircularProgressIndicator(
            valueColor: AlwaysStoppedAnimation<Color>(_color),
            backgroundColor: Colors.white,
          ),
        );
      },
    );
  }

  static hideLoading() {
    _hideLoadFun?.call();
    _hideLoadFun = null;
  }
}

class _CustomWidget extends StatelessWidget {
  final CancelFunc? cancelFunc;
  final String msg;
  final Color color;
  final bool isDark;

  _CustomWidget({
    required this.msg,
    required this.color,
    this.cancelFunc,
    this.isDark = false,
  });

  @override
  Widget build(BuildContext context) {
    final textColor = isDark ? Color(0xFFF2F2F2) : color;
    return Card(
      color: isDark ? Color(0xFF1F1B34) : Colors.white,
      child: ListTile(
        title: Text(
          msg,
          style: TextStyle(color: textColor, fontSize: D.sp(32), fontWeight: FontWeight.w400),
        ),
        trailing: IconButton(
          icon: Icon(
            CupertinoIcons.clear,
            color: textColor,
            size: D.w(38),
          ),
          onPressed: cancelFunc,
        ),
      ),
    );
  }
}
