import 'package:flutter/material.dart';
import 'package:get/get_instance/src/get_instance.dart';
import 'package:hgg_base/src/model/x_base_model.dart';
import 'package:hgg_base/src/utils/x_log.dart';

import '../../hgg_base.dart';

/// 可以添加 model 的 StatelessWidget
abstract class XGetView<T> extends StatelessWidget {
  const XGetView({Key? key, this.tag}) : super(key: key);

  final String? tag;

  T get model => GetInstance().find<T>(tag: tag);

  @override
  Widget build(BuildContext context);

  void closeModel({String? tag}) {
    try {
      if (Get.isRegistered<T>(tag: tag)) {
        XLog.d('$T 没有自动清理,这里手动清理!');
        Get.delete<T>(tag: tag);
      }
    } catch (e) {}
  }
}

/// 保持页面状态的 state ,可以添加 model
abstract class XGetState<T extends StatefulWidget, M extends XBaseModel>
    extends State<T> with AutomaticKeepAliveClientMixin {
  XGetState({this.tag});

  final String? tag;

  M get model => GetInstance().find<M>(tag: tag);

  @override
  Widget build(BuildContext context);

  @override
  bool get wantKeepAlive => true;
}

/// 保持页面状态的 state
abstract class XState<T extends StatefulWidget> extends State<T>
    with AutomaticKeepAliveClientMixin {
  @override
  Widget build(BuildContext context);

  @override
  bool get wantKeepAlive => true;
}
